
var global = typeof window !== 'undefined'
? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
;

(function() {
 function guid() {
     return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
         var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
         return v.toString(16);
     });
 }
 var currentNaviID = guid();
 function needReport(params) {
    if (window.location.href === 'about:blank') {
        return false;
    }
    return true;
 }
 // 覆盖类型
 function jsIESLiveTimingMonitorCover(params, service) {
    if (!needReport(params)) {
        return
    }
    params.serviceType = service
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveTimingMonitorCover.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorCover) {
        iesLiveTimingMonitorCover(formatMonitorParams(params));
    }
 }
 
 // 累加类型
function jsIESLiveTimingMonitorAccumulate(params, service) {
    if (!needReport(params)) {
        return
    }
    params.serviceType = service
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveTimingMonitorAccumulate.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorAccumulate) {
        iesLiveTimingMonitorAccumulate(formatMonitorParams(params));
    }
}

// 透传类型
function jsIESLiveTimingMonitorReportDirectly(params, service) {
    if (!needReport(params)) {
        return
    }
    if (service === 'diff') {
        return jsIESLiveTimingMonitorReportDiff(params, service)
    }
    params.serviceType = service
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveTimingMonitorReportDirectly.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorReportDirectly) {
        iesLiveTimingMonitorReportDirectly(formatMonitorParams(params));
    }
}
 
 // diff类型
 function jsIESLiveTimingMonitorReportDiff(params, service) {
    if (!needReport(params)) {
        return
    }
    params.serviceType = service
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveTimingMonitorReportDiff.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorReportDiff) {
        iesLiveTimingMonitorReportDiff(formatMonitorParams(params));
    }
 }
 

// 平均值类型
function jsIESLiveTimingMonitorAverage(params, service) {
    if (!needReport(params)) {
        return
    }
    params.serviceType = service
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveTimingMonitorAverage.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorAverage) {
        iesLiveTimingMonitorAverage(formatMonitorParams(params));
    }
}
 
 // 自定义类型
 function jsIESLiveTimingMonitorReportCustom(event_name, params) {
    if (!needReport(params)) {
        return
    }
    var extra = typeof params.extra !== 'undefined' ? params.extra : {}
    extra['event_name'] = event_name
    params['extra'] = extra;
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveTimingMonitorReportCustom.postMessage(formatMonitorParams(params));
    } else if (window.iesLiveTimingMonitorReportCustom) {
        iesLiveTimingMonitorReportCustom(formatMonitorParams(params));
    }
 }

 // pv
 function jsIESLiveTimingMonitorReportStage(params, service) {
     if (!needReport(params)) {
         return
     }
     params.serviceType = service
     if (window.webkit) {
         window.webkit.messageHandlers.iesLiveTimingMonitorReportStage.postMessage(formatMonitorParams(params));
     } else if (window.iesLiveTimingMonitorReportStage) {
         iesLiveTimingMonitorReportStage(formatMonitorParams(params));
     }
 }
 
function formatMonitorParams(params) {
    var commonParams = window.SlardarHybrid.shared.config.commonParams
    if (typeof commonParams !== 'undefined') {
        for(var key in commonParams) {
            params[key] = commonParams[key]
        }
    }
    if (window.history.length <= 1) {
        params.firstPage = true
    }
    params.url = window.location.href
    params.navigation_id = currentNaviID
    return JSON.parse(JSON.stringify(params))
}
 
 // initTime
 function jsIESLiveCalculateInitTime(jsDuration) {
    if (!needReport([jsDuration])) {
        return
    }
    var urlStr = window.location.href;
    var body = {url:urlStr, duration:jsDuration}
    if (window.webkit) {
        window.webkit.messageHandlers.iesLiveCalculateInitTime.postMessage(body);
    } else if (window.iesLiveCalculateInitTime) {
        iesLiveCalculateInitTime(body);
    }
 }
 
 function onDomContentLoaded() {
    var msg = {}
    msg.stage = 'DomContentLoaded';
    jsIESLiveTimingMonitorReportStage(msg, 'pv')
    window.setTimeout(function() {
                      // native 计算webview初始化时间
                      if (window.history.length <= 1) {
                        jsIESLiveCalculateInitTime(performance.now());
                      }
                   }, 0)
 }

 
 var bridge = {}
 bridge.cover = jsIESLiveTimingMonitorCover
 bridge.accumulate = jsIESLiveTimingMonitorAccumulate
 bridge.reportDirectly = jsIESLiveTimingMonitorReportDirectly
 bridge.average = jsIESLiveTimingMonitorAverage
 
 global.jsIESLiveTimingMonitor = bridge
 // public bridge
 var publicBridge = {}
 publicBridge.customReport = jsIESLiveTimingMonitorReportCustom
 global.jsIESWebViewMonitor = publicBridge
 
 
 // Use the handy event callback
 window.addEventListener( "DOMContentLoaded", onDomContentLoaded );
 
 function sendError(errorDic) {
    var eventValue = {}
    var category = errorDic.category;
    eventValue[category] = 1;
    var message = {}
    message.ev_type = category
    message.event = eventValue
    jsIESLiveTimingMonitorAccumulate(message, 'overview')
 }
 
 var addEventListener = global.addEventListener;
 // https://developer.mozilla.org/zh-CN/docs/Web/Events/unhandledrejection
 if (addEventListener) {
 global.addEventListener('unhandledrejection', function (event) {
                         if (event) {
                         var reason = event.reason;
                         sendError({
                                          title: 'unhandledrejection',
                                          msg:'unhandledrejection' + reason,
                                          category: 'js_error_count',
                                          level: 'error'
                                          });
                         }
                         }, true);
 global.addEventListener('error', function (event) {
                         if (event) {
                         var target = event.target || event.srcElement;
                         var isElementTarget = target instanceof HTMLElement;
                         var url = target.src || target.href;
                         if (!isElementTarget) {
                         sendError({
                                          title:target.nodeName,
                                          msg:url,
                                          category:'js_error_count',
                                          level: 'error'
                                          });
                         };
                         }
                         }, true);
 }
 
})()
